type t = int32

let address_regexp =
  let octet_regexp_string = "\([0-9][0-9]?[0-9]?\)" in
  let address_regexp_string =
    octet_regexp_string ^ "\." ^ octet_regexp_string ^ "\." ^
    octet_regexp_string ^ "\." ^ octet_regexp_string
  in
  Str.regexp ("^" ^ address_regexp_string ^ "$")

let of_int32 = function n -> n

let to_int32 = function n -> n

let of_string = Int32.of_string

let to_string = Int32.to_string

let of_address_string string =
  let n = ref Int32.zero in
  if (Str.string_match address_regexp string 0) then
    for i = 1 to 4 do
      let octet = Int32.of_string (Str.matched_group i string) in
      n := Int32.logor !n (Int32.shift_left octet (8 * (3 - i)))
    done
  else
    failwith "hostlong_of_string";
  !n

let to_address_string n =
  let octets = ref [] in
  let octet_mask = Int32.of_int 0xff in
  for i = 0 to 3 do
    let octet =
      Int32.logand octet_mask (Int32.shift_right_logical n (i * 8))
    in
    octets := (Int32.to_string octet) :: !octets
  done;
  String.concat "." !octets
