type t

val of_int32 : int32 -> t
      (* Convert the given 32-bit integer (type [int32]) to a hostlong
	 (type [Hostlong.t]). *)
val to_int32 : t -> int32
      (* Convert the given hostlong (type [Hostlong.t]) to a 32-bit integer
	 (type [int32]). *)

val of_string : string -> t
      (* Convert the given string to a hostlong (type [Hostlong.t]). *)

val to_string : t -> string
      (* Return the string representation of its argument,
         in signed decimal. *)

val of_address_string : string -> t
      (* Convert the given string to a hostlong (type [Hostlong.t]). *)

val to_address_string : t -> string
      (* Return the string representation of its argument,
         in signed decimal. *)
